<template>
    <q-select :options="options" :option-label="textField" :option-value="primaryKey" map-options></q-select>
</template>
<script>

export default {
    props: ['name', 'extraPostData'],
	inject: ['module'],
    data() {
        return {
            selectedOption: null,
            options: [],
            textField: 'text',
            primaryKey: 'ID',
            searchTerm: '',
            pagination: false,
            pageLoaded: 0
        }
    },
    computed: {
        postData() {
            let postData = { Module_Name: this.module.Module_Name, id: this.name }
            if (this.pagination) {
                postData.page = this.pageLoaded + 1
            }
            if (this.searchTerm !== '' && this.searchTerm !== null) {
                postData.search = this.searchTerm
            }
            if (this.extraPostData !== undefined) {
                postData = Object.assign(postData, this.extraPostData)
            }
            return postData
        }
    },
    methods: {
        getData() {
            var self = this
            axios.post('welcome/selectbox', objectToFormData(this.postData)).then(({ data }) => {
                let payload = data.datatype.result
                if (payload.results !== undefined) {
                    this.options = this.options.concat(payload.results)
                }
                console.log(payload)
                if (payload.primarykey !== undefined) {
                    this.primaryKey = payload.primarykey
                }
                if (payload.textfield !== undefined) {
                    this.textField = payload.textfield
                }
                if (payload.pagination?.more) {
                    this.pagination = payload.pagination?.more
                } else {
                    this.pagination = false
                }
            })
        }
    },
    created() {
        this.getData = Quasar.debounce(this.getData)
        this.getData()
    }

}
</script>
